<?php

namespace Drupal\a11n_code_rest\Controller;

use Drupal\Component\Serialization\Json;
use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Link;
use Drupal\Core\Url;

class DocumentationController extends ControllerBase {

//    $table[] = [
//      'link' => $this->apiLinkRenderable('authorization_code.send_code'),
//      'description' => [
//        '#type' => 'details',
//        '#title' => t('Sends a code to the client'),
//        'details' => [
//          '#markup' => t('ABC')
//        ]
//      ],
//      'request' => [
//        '#type' => 'details',
//        '#title' => t('Request'),
//        'details' => [
//          '#type' => 'html_tag',
//          '#tag' => 'pre',
//          '#value' => Json::encode([
//            'method' => 'debug',
//            'argument' => 'tbd@example.com',
//          ])
//        ]
//      ],
//      'response' => [
//        '#type' => 'details',
//        '#title' => t('Response'),
//        'details' => [
//          '#markup' => $this->t('Example response')
//        ]
//      ],
//    ];

  public function getDocs() {
    $table = [
      '#type' => 'table',
      '#header' => $this->buildHeader(),
    ];

    $table[] = $this->buildSendCodeRow();
    $table[] = $this->buildVerifyCodeRow();

    return $table;
  }

  protected function buildHeader() {
    return [
      'link' => [
        'data' => $this->t('Link'),
      ],
      'description' => [
        'data' => $this->t('Description'),
        'class' => [
          RESPONSIVE_PRIORITY_LOW
        ]
      ],
      'example' => [
        'data' => $this->t('Examples'),
        'class' => [
          RESPONSIVE_PRIORITY_MEDIUM
        ]
      ]
    ];
  }

  protected function buildExampleRow($api_key) {
    return [
      'link' => $this->apiLinkRenderable("rest.authorization_code.{$api_key}.POST"),
      'description' => [
        '#type' => 'details',
        '#title' => 'STUB TITLE',
        'details' => [
          '#markup' => 'STUB TEXT'
        ]
      ],
      'request' => [
        '#type' => 'details',
        '#title' => 'STUB TITLE',
        'details' => [
          '#type' => 'html_tag',
          '#tag' => 'pre',
          '#value' => 'STUB TEXT'
        ]
      ]
    ];

  }

  protected function buildSendCodeRow() {
    $row = $this->buildExampleRow('send');

    $row['description']['#title'] = t('Send authorization code');
    $row['description']['description']['details']['#markup'] = t('Use this API to send a verification code to the client.');
    $row['description']['request']['details']['#value'] = Json::encode([
      'method' => 'debug',
      'argument' => 1
    ]);

    return $row;
  }

  protected function buildVerifyCodeRow() {
    $row = $this->buildExampleRow('authorize');

    $row['description']['#title'] = t('Verify authorization code');
    $row['description']['description']['details']['#markup'] = t('Use this API to authorize a session using an authorization code.');
    $row['description']['request']['details']['#value'] = Json::encode([
      'method' => 'debug',
      'argument' => 1,
      'code' => '099432',
    ]);

    return $row;
  }

  /**
   * @param $route_name
   * @return array
   */
  protected function apiLinkRenderable($route_name) {
    $url = Url::fromRoute($route_name);
    return Link::fromTextAndUrl($url->getInternalPath(), $url)->toRenderable();
  }
}