<?php

namespace Drupal\authorization_code\Annotation;

use Drupal\Component\Annotation\Plugin;

/**
 * @Annotation
 */
class AccountIdentifier extends Plugin {

  /**
   * The machine name of this plugin.
   *
   * @var string
   */
  public $id;

  /**
   * The display name of this plugin.
   *
   * @var string
   */
  public $label;

  /**
   * The acceptable typed data definition of the identifier.
   *
   * @var string
   */
  public $type = 'any';

  /**
   * {@inheritdoc}
   */
  public function __construct($values) {
    $values['data_definition'] = NULL;
    if (isset($values['type'])) {
      $values['data_definition'] = \Drupal::typedDataManager()
        ->createDataDefinition($values['type']);
    }

    parent::__construct($values);
  }

}
