<?php

namespace Drupal\authorization_code\Plugin;

use Drupal\Component\Plugin\PluginInspectionInterface;

/**
 * Required interface for all account identifier plugins.
 */
interface AccountIdentifierInterface extends PluginInspectionInterface {

  /**
   * @param mixed $identifier
   *   The account identifier.
   * @return bool
   */
  public function isValid($identifier);

  /**
   * @param mixed $identifier
   *   The account identifier.
   * @return \Symfony\Component\Validator\ConstraintViolationListInterface
   */
  public function validate($identifier);

  /**
   * Loads the user object from the provided argument.
   *
   * @param mixed $identifier
   *   The account identifier.
   *
   * @return null|int
   *   User id, or null if no user was matched to the identifier.
   */
  public function getUserId($identifier);

  /**
   * Loads the user object from the provided argument.
   *
   * @param mixed $identifier
   *   The account identifier.
   *
   * @return null|\Drupal\user\UserInterface
   *   The fully loaded user object, or null if no user was matched to the
   *   identifier.
   */
  public function loadUser($identifier);

}
